Page MenuHomeFreeBSD

gic_v3: consolidate per-cpu redistributor information
ClosedPublic

Authored by jchandra on Apr 8 2019, 2:14 AM.

Details

Summary

Update 'struct gic_redists' to consolidate all per-cpu redistributor information into a new 'struct redist_pcpu'. Provide a new interface (GICV3_IVAR_REDIST) for the GIC driver which retrieves the above per-cpu data.

This per-cpu redistributor struct will be later used to improve GIC ITS setup.

While there, remove some unused fields in gic_v3_var.h interface.
No functional changes.

Diff Detail

Repository
rS FreeBSD src repository
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.

Event Timeline

jchandra created this revision.Apr 8 2019, 2:14 AM
jchandra updated this revision to Diff 57924.May 26 2019, 11:24 PM
andrew added inline comments.May 28 2019, 9:54 AM
sys/arm64/arm64/gic_v3.c
393–394 ↗(On Diff #57924)

If you plan on MFCing this you should keep GICV3_IVAR_REDIST_VADDR to preserve KBI. It can be removed in a later commit that doesn't get an MFC.

sys/arm64/arm64/gic_v3_var.h
96 ↗(On Diff #57924)

I would make GICV3_IVAR_REDIST 1002 with a comment that 1001 was GICV3_IVAR_REDIST_VADDR as it's a change in KBI.

jchandra updated this revision to Diff 58020.May 29 2019, 3:38 AM
jchandra edited the summary of this revision. (Show Details)

fixes for addressing andrew's not on KABI.

andrew accepted this revision.May 29 2019, 8:50 AM
This revision is now accepted and ready to land.May 29 2019, 8:50 AM
This revision was automatically updated to reflect the committed changes.